'''
 This file is called from java GUI to analyze a task set
 The task set has been saved in an XML file
'''

import drt.model
import drt.analysis.timesstub.spstub
import util
import sys
#from __builtin__ import Node


# make task set and run analysis
# task_list = parse_xml('C:\\cse561\\times\\3tasks.xml') # sys.argv[1]) # 'DRT.xml') ('new_DRT.xml') #

def main():
    tasks = util.parse_xml( sys.argv[1]) # 'new_DRT.xml') # 'S2.xml') #       
    tname = sys.argv[2]
    policy = sys.argv[3]    # SP or EDF
    
    task_list = [t for t in tasks if len(t.get_jobs()) > 0]     # exclude empty tasks because the drtlib cannot handle this case
    task_list = sorted(task_list, key=lambda task: task._priority)   # sort by priority
    lp_task = [t for t in task_list if t._name == tname]
    lp_task = lp_task[0]
    
    res = []
    if (len(task_list) == 1):    
        res = [j.get_e() for j in lp_task.get_jobs()]
                 
    elif (len(task_list) > 1):
        maxTime = util.maxD(task_list) + 1
        util.make_graphs_connected(task_list, maxTime)
            
        wcets = dict() # [j.get_e() for j in lp_task.get_jobs()]
        for j in lp_task.get_jobs():
            wcets[j] = j._e 
            j._e = 0
        
        TS = drt.model.SPTaskSet(task_list)            
        for j in lp_task.get_jobs():
            for lpjob in lp_task.get_jobs():
                lpjob._e = 0
            
            j._e = wcets[j]
            if j._e == 0:
                res.append(0)
                continue
            
            jdeadline = j._d
            respTime = -1
            for dl in range(j._e, jdeadline + 1):
                j._d = dl
                rt = drt.analysis.timesstub.spstub.is_sp_lowestpriority_schedulable(lp_task, TS)
                if(rt):
                    respTime = dl
                    break
                                
            res.append(respTime)
            
            '''
            TS = drt.model.SPTaskSet(task_list)
            rt = drt.analysis.timesstub.spstub.is_sp_schedulable(TS)
            res.append(rt)
            '''
        
    names = [j._name for j in lp_task.get_jobs()]
    
    print (str(names))
    print (str(res))  
    
main()