'''
 This file is called from java GUI to analyze a task set
 The task set has been saved in an XML file
'''

import drt.model
import drt.analysis.timesstub.spstub
import drt.analysis.timesstub.edfstub
import util
import sys
#from __builtin__ import Node

# make task set and run analysis
# task_list = parse_xml('C:\\cse561\\times\\3tasks.xml') # sys.argv[1]) # 'DRT.xml') ('new_DRT.xml') #
try:
    '''
    tasks = util.parse_xml('DRT.xml') # 
    metric = 'DBF'        # MRF or DBF
    maxD = 100 # 
    '''
    tasks  = util.parse_xml(sys.argv[1]) # 
    metric = sys.argv[2]        # MRF or DBF
    maxD   = int(sys.argv[3])   # maximum time for which calculate the rf
        
    util.make_graphs_connected(tasks , maxD + 1)
    
    for t in tasks:
        if metric == 'MRF':
            bfs = [[0] * maxD]
        elif metric == 'DBF':
            bfs = [[0] * (maxD+2)]

        if len(t.get_jobs()) > 0:
            TS = drt.model.TaskSet([t])
            if metric == 'MRF':
                bfs = drt.analysis.timesstub.spstub.get_mrf(TS, maxD)
            elif metric == 'DBF':
                bfs = drt.analysis.timesstub.edfstub.get_dbf(TS, maxD + 1)
        print(bfs[0]) 
            
    
    
except IndexError as e:
    z = e
    print('Analysis encountered an error in DRTLIB')
    print(z)
#except:
  #  e = sys.exc_info()[2]
 #   print('Analysis encountered an error in DRTLIB')
#    print("Error: %s" % str(e))
