# This file is part of libdrt.
#
# Written 2011-2014 by Martin Stigge, Pontus Ekberg.
#
# GPLv3 applies.

import time

class Timer(object):
    """Simple timer. Starts running immediately when instantiated.
    Returns time since start when stopped.
    """

    def __init__(self):
        self._starttime = float(0)
        self._endtime = float(0)
        self.start()

    def start(self):
        self._starttime = time.time()

    def stop(self):
        self._endtime = time.time()
        return self.get_t()

    def get_t(self):
        return self._endtime - self._starttime

# Used to collect statistics, indexed by analyser objects
stats = dict() 
        


# vim:textwidth=79:shiftwidth=4:tabstop=4:cc=80:expandtab:autoindent

