package analysis.model;

import java.util.LinkedList;

import enums.TaskModel;

import services.RunResult;
import analysis.model.enums.Processor;

import main.Manager;
import main.TaskSet;

public class AnalysisMgr {

	private Manager mgr;
	
	public AnalysisMgr(Manager m) {
		mgr = m;
	}

	public void stop() {
		mgr.stop();
	}

	public boolean hasNonEmptyTask() {
		return mgr.hasNonEmptyTask();
	}

	public LinkedList<String> analysisSyntaxErrors() {
		return mgr.analysisSyntaxErrors();
	}

	public RunResult runParitioning(Settings cfg) throws Exception {
		return mgr.runParitioning(cfg);
	}

	public void setPrio(String[] names, String coreName) {
		if (coreName.equalsIgnoreCase("Unallocated"))
			return;
		mgr.setPriorities(names);		
	}
}
