package main;

import enums.ActionType;
import enums.SendSemantic;

public class EdgeParam {
	public	int			interRel;
	public	String 		action;
	public	ActionType	aType;
	public  SendSemantic send;
	
	public static ActionType defaultAction() {
		return ActionType.None;
	}
	
	public static SendSemantic defaultSendSem() {
		return SendSemantic.Blocking;
	}
	
	public EdgeParam() {
		action = "";
		aType  = defaultAction();
		send   = defaultSendSem(); 
	}
	
	public EdgeParam(int ir, String a, ActionType t, SendSemantic s) {
		interRel = ir;
		action = a;
		aType = t;
		send = s;
	}
	
	public String toString() {
		String act = action;
		if (aType == ActionType.Send)
			act += "!";
		else if (aType == ActionType.Receive)
			act += "?";
		
		return interRel + " [" + act + "]";
	}
	
	public EdgeParam cloneMe() {
		EdgeParam cloned = new EdgeParam();
		cloned.interRel = this.interRel;
		cloned.action   = new String(this.action);
		cloned.aType    = this.aType;
		cloned.send     = this.send;
		return cloned;
	}
	
	public void loadData(EdgeParam orig) {
		this.interRel = orig.interRel;
		this.action   = orig.action;	
		this.aType 	  = orig.aType;
		this.send     = orig.send;
	}
}
