package main;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.EventQueue;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.text.AttributeSet;
import javax.swing.text.DefaultCaret;
import javax.swing.text.Document;
import javax.swing.text.StyleConstants;

import util.GUIAttr;

public class NotesPanel extends JPanel {
	
	JLabel title;
	JTextPane pane;
	
	public NotesPanel() {
		setLayout( new BorderLayout() );

        title = new JLabel( "Notes:" );
        pane = createPane();
        JScrollPane scrollPane = new JScrollPane();
        scrollPane.setViewportView(pane);
        
        add( title, BorderLayout.NORTH );
        add( scrollPane, BorderLayout.CENTER );
	}

	private JTextPane createPane() {
		JTextPane p = new JTextPane();
        p.setFont(p.getFont().deriveFont(13f));
        DefaultCaret caret = (DefaultCaret)p.getCaret();
        caret.setUpdatePolicy(DefaultCaret.ALWAYS_UPDATE);
        return p;
	}
	
	public void print(String msg) {
		AttributeSet attr = GUIAttr.cont.addAttribute(GUIAttr.set, 
				StyleConstants.Foreground, Color.BLACK);
		print(msg + "\r\n", attr);
	}
	
	public void println(String msg) {
		print( msg + "\r\n");
	}
	
	public void println(String msg, Color c) {
		AttributeSet attr = GUIAttr.cont.addAttribute(GUIAttr.set, 
				StyleConstants.Foreground, c);
		print(msg + "\r\n", attr);
	}
	
	public void print(final String msg, final AttributeSet attr) {
		if (msg == null)
			return;
		if (msg.isEmpty())
			return;
		
	    EventQueue.invokeLater(new Runnable() {
            public void run() {
                try {
                	Document doc = pane.getStyledDocument();            		
        	    	int len = doc.getLength();
        			doc.insertString(len, msg, attr);
                } catch (Exception e) {
                    Util.error(e);
                }
            }
        });		    
	}
	
	public void printDashedLine() {
		print("------------------------------------" + "\r\n");
	}
}
