package services;

import java.util.LinkedList;

public class RunResult {
	
	private	String[]	command;
	private	String 		message;
	private	String 		log;
	private	boolean		success;			// indicates whether running the analysis engine has been terminated successfully
	private	boolean		schedulable;		// indicates whether the task set was schedulable
	private	int			exitValue;
	private	double		run_time;			// response time
	private	Exception	exception;
	private	LinkedList<String> 	lines;		// lines read as the output of the analysis engine 
	
	// Constructor
	public RunResult(String[] cmd) {
		command = cmd;
		success = true;
		message = "";
		lines   = new LinkedList<String>();		
	}
	
	public void addLine(String line) {
		lines.add(line);		
	}

	public int linesNo() {
		if(lines == null)
			return 0;
		return lines.size();
	}

	public void succeed(boolean b) {
		success = b;		
	}

	public boolean succeeded() {
		return success;
	}
	
	public double getRun_time() {
		return run_time;
	}

	public void setRunTime(double run_time) {
		this.run_time = run_time;
	}

	public String message() {
		return message;
	}

	public String getLine(int i) {
		return 	lines.get(i);
	}

	public LinkedList<String> lines() {
		return lines;
	}

	public void setMessage(String msg) {
		message = msg;
	}

	public String[] linesArr() {		
		return lines.toArray(new String[0]);
	}

	public boolean isSchedulable() {
		return schedulable;
	}

	public void setSchedulable(boolean schedulable) {
		this.schedulable = schedulable;
	}

	public int exitValue() {
		return exitValue;
	}

	public void setExitValue(int val) {
		exitValue = val;		
	}

	public String toStr() {
		String res = "";
		for (String s : lines)
			res += s + "\n";
		return res;
	}

	public void setException(Exception e) {
		exception = e;		
	}

	public Exception getException() {
		return exception;
	}

	public String[] getCommand() {
		return command;
	}
	
	public void setLog(String log) {
		this.log = log;
		
	}

	public String getLog() {
		return log;
	}
}
