package simulator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JToolBar;

import main.Util;

public class SimToolBar extends JToolBar implements ActionListener {

	private SimTab 		simTab;
	private JButton		execButton;
	private JButton 	pauseButton;
	private JButton 	rsetButton;
	private JButton 	stepButton;
	private JButton 	run2dButton;	
	private JButton 	cnfgButton;
	
	public SimToolBar(SimTab simTab) {
		this.simTab = simTab;
		createButtons();
				
		add(Box.createHorizontalGlue());
		add(rsetButton);
		add(pauseButton);
		add(execButton);
		add(stepButton);
		add(run2dButton);
		add(Box.createHorizontalGlue());		
		add(cnfgButton);		
	}
	
	private void createButtons() {
		ImageIcon iconReset = Util.getIcon("/rewind.gif");		
		ImageIcon iconPause = Util.getIcon("/pause.gif");
		ImageIcon iconExec = Util.getIcon("/exec.gif");
		ImageIcon iconStep = Util.getIcon("/step.gif");
		ImageIcon iconRunD = Util.getIcon("/run2d.gif");
		ImageIcon iconConf = Util.getIcon("/conf.png");
		
		execButton = new JButton(iconExec);
		pauseButton = new JButton(iconPause);
		rsetButton = new JButton(iconReset);
		stepButton = new JButton(iconStep);
		run2dButton = new JButton(iconRunD);
		cnfgButton  = new JButton(iconConf);
		
		execButton.setToolTipText("Run Simulation");
		pauseButton.setToolTipText("Pause Simulation");
		rsetButton.setToolTipText("Stop (and Reset) Simulation");
		stepButton.setToolTipText("Run Simulation One Step");
		run2dButton.setToolTipText("Run to the First Deadline Miss");
		cnfgButton.setToolTipText("Settings");
		
		execButton .addActionListener(this);
		pauseButton.addActionListener(this);
		rsetButton .addActionListener(this);
		stepButton .addActionListener(this);
		run2dButton.addActionListener(this);
		cnfgButton.addActionListener(this);
	}
		
	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == execButton)
			simTab.run();
		else if (e.getSource() == pauseButton)
			simTab.pause();		
		else if (e.getSource() == rsetButton)
			simTab.stop();
		else if (e.getSource() == stepButton)
			simTab.step();
		else if (e.getSource() == run2dButton)
			simTab.Run2DLmiss();
		else if (e.getSource() == cnfgButton)
			simTab.getUserSetting();
		else 
			System.out.println("Warning: Unimplemented action button");
	}		
}