package simulator.engine;

import main.JobType;


/*
 * Simulator Job
 */
class SJob {
	int 	remainedExecution;
	JobType	masterJob;
	int 	arrival;
	int		relDLine;		// relative deadline		
	
	public SJob(JobType job, int arrival) {
		this.masterJob 	= job;
		this.arrival 	= arrival;
		this.remainedExecution = job.WCET();
		this.relDLine	= job.deadline();
	}

	public void progress(int elapsed) {
		if (elapsed > remainedExecution)
			System.out.println("Warning in job progress in simulation: job execution exceeded " + elapsed + ", job = " + masterJob.getName());
		remainedExecution = remainedExecution - elapsed; 
	}
	
	public String toString() {
		return masterJob.getName() + "(" + masterJob.WCET() + "," + masterJob.deadline() + ")";
	}
	
	int absDLine() {
		return arrival + relDLine;
	}
}
