package simulator.view;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Toolkit;

import javax.swing.JComponent;


public class Ruler extends JComponent {
    public static final int INCH = Toolkit.getDefaultToolkit().
            getScreenResolution();
    public static final int HORIZONTAL = 0;
    public static final int VERTICAL = 1; 
    public int orientation;
    
    private int increment;
    private int units;
    private int PAD;
    private int offset;
    private	String[] names;
    private Color fontColor = Color.BLACK;	// default
    
    public Ruler(int o, int p, int of, String[] ns) {
        orientation = o;
        PAD = p;
        names = ns;
        offset = of;
        setIncrementAndUnits();
    }
 
    public Ruler(int o, int p, int of, String[] ns, Color c) {
        this(o, p, of, ns);
        fontColor = c;
    }
     
    private void setIncrementAndUnits() {
        units = (int)((double)INCH / (double)2.54); // dots per centimeter
        increment = units;    
    }
 
    public int getIncrement() {
        return increment;
    }
 
    public void setPreferredHeight(int ph) {
    	int pw = getPreferredSize().width;
        setPreferredSize(new Dimension(pw, ph));
    }
 
    public void setPreferredWidth(int pw) {
    	int ph = getPreferredSize().height;
        setPreferredSize(new Dimension(pw, ph));
    }
 
    protected void paintComponent(Graphics g) {
        Rectangle drawHere = g.getClipBounds();

        // Fill clipping area with dirty brown/orange.
        g.setColor(new Color(230, 230, 230));
        g.fillRect(drawHere.x, drawHere.y, drawHere.width, drawHere.height);
 
        // Do the ruler labels in a small font that's black.
        //g.setFont(new Font("SansSerif", Font.PLAIN, 10));
        g.setColor(fontColor);
 
        for (int i = 0; i < names.length; i++) {
        	int y = offset + i * PAD; // h - (offset + i*PAD); // h-PAD-i*PAD;
        	g.drawString(names[i], 9, y + 5);
        	// SimUtil.drawString(g2, names[i], xPAD/2, y);
    	}        
        g.setColor(Color.BLACK);
    }    
}
