package synthesis.model.ccoder;

import main.Edge;

public abstract class CCoder {
	protected static String NL  = CSynthesizer.NL;
	protected static String TAB = CSynthesizer.TAB;

	protected static String TAB(int n) {
		String TABn = "";
		for (int i = 0; i < n; i++) {
			TABn = TABn + TAB;
		}
		return TABn;
	}

	public static String beginTask(String name) {
		String code = "static void " + name + " (void *pvParameters)" + NL;
		code += "{" + NL;
		return code;
	}
	
	public static String endTask() {
		String code = "}" + NL;
		return code;
	}
	
	public static String indent(int t, String code) {
		String s = "";
		
		if(code == null)
			return s;
				
		String[] lines = code.split("\n");
		for (int i = 0; i < lines.length; i++)
			s += TAB(t) + lines[i] + NL;		
		return s;
	}
	
/*	protected static String job_transit(String name, int index) {
		return name + "=" + index;
	}*/
	
	protected static String edge_delay(Edge e) {
		return e.srcName() + "_to_" + e.dstName() + "_delay" + e.index();
	}
}