package synthesis.model.ccoder;

import java.util.Collections;
import java.util.LinkedList;

import main.Edge;
import main.JobType;
import main.Task;
import synthesis.model.Settings;
import synthesis.model.ccoder.CEdgeCoder;

public class CJobCoder extends CCoder {
	
	public static String JobCode(JobType j) {
		String code = "";
/*		String name = j.getName();
		// String[] lines = j.getCode().split("\n");
		
		code += TAB(2) + beginProc(name + "_code") + NL;
		code += TAB(2) + "begin" + NL;
		code += TAB(3) + "Put_Line (\" In job " + t.getName() + "." + name + " \");" + NL;*/
		code += indent(3, j.getCode()); 

		//code += TAB(2) + endProc(name + "_code");
		return code;
	}
	
	public static String synthCode(JobType j, Task t, Task[] tasks, Settings conf) {

		String code = "";
		//code += TAB(6) + j.getName() + "_code;" + NL; // call the associated  procedure
		int i = 0;
		Edge e;
		
		LinkedList<Edge> outEdges = j.getBranchOrders();
		Collections.sort(outEdges); // sorting is done here instead of job level

		if (outEdges.size() == 0) {
			code += TAB(6) + "break;" + NL; // task is finished
			return code;
		}
		
		
		for (i = 0; i < outEdges.size(); i++){
			e = outEdges.get(i);
			
			// here is a problem with indexing 
			code += CEdgeCoder.synthCode(e,t,tasks, conf, t.getJobIndex(e.destin()));		
	
		}
		
	
		// code needed for exit case
		return code;
	}

}