// This tool bar is used for drawing/modifying tasks
// This is placed in the drawingPane

package taskeditor;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JToolBar;

import main.Util;


public class DrawToolBar extends JToolBar {
	
	public DrawToolBar(DrawingPane drawPane) {
		ImageIcon iconCircle  = Util.getIcon("/circle_small.png");
		ImageIcon iconArc 	  = Util.getIcon("/arc.png");
		ImageIcon iconPointer = Util.getIcon("/mouse_pointer.png");
		
		JButton circleButton  = new JButton(iconCircle);
		JButton arcButton     = new JButton(iconArc);
		JButton pointerButton = new JButton(iconPointer);
		
		circleButton. addActionListener(new CircleActionListner(drawPane));
		arcButton.    addActionListener(new ArcActionListner(drawPane));
		pointerButton.addActionListener(new PointerActionListner(drawPane));
		
		circleButton. setToolTipText("Create new vertex (i.e. new job type)");
		arcButton.    setToolTipText("Create new edge");
		
		add(circleButton);
		add(arcButton);
		add(pointerButton);
		addSeparator();
	}

}


/*
 * This is related to the circle button in the toolbar of drawing a task
 */
class CircleActionListner implements ActionListener {
	DrawingPane drawPanel;

	public CircleActionListner(DrawingPane drawingPane) {
		this.drawPanel = drawingPane;
	}

	public void actionPerformed(ActionEvent evt) {
		this.drawPanel.setDrawingState(DrawStatus.CIRCLE);
	}
}


class ArcActionListner implements ActionListener {
	DrawingPane drawPanel;

	public ArcActionListner(DrawingPane drawingPane) {
		this.drawPanel = drawingPane;
	}

	public void actionPerformed(ActionEvent evt) {
		this.drawPanel.setDrawingState(DrawStatus.ARC);
	}
}


class PointerActionListner implements ActionListener {
	DrawingPane drawPanel;

	public PointerActionListner(DrawingPane drawingPane) {
		this.drawPanel = drawingPane;
	}

	public void actionPerformed(ActionEvent evt) {
		this.drawPanel.setDrawingState(DrawStatus.NONE);
		this.drawPanel.setNewEdgeSrcJob(null);
	}
}