package taskeditor;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.LayoutManager;
import java.awt.Point;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.SwingConstants;

import util.GUIUtil;

public class EditorInfoBar extends JPanel {
	
	JLabel  taskLabel;	
	JLabel  xLabel;
	JLabel  yLabel;
	
	public EditorInfoBar(int slack) {
		setBorder( GUIUtil.getGrayTitleBorder("") );
		setLayout(new BoxLayout(this, BoxLayout.LINE_AXIS));
		
		createLabels();
		
		Box horizontalBox = Box.createHorizontalBox();

		horizontalBox.add( Box.createHorizontalStrut(slack + 10) );
		//horizontalBox.add(new JPanel(new JSeparator(SwingConstants.VERTICAL)));
		horizontalBox.add(taskLabel);	    
	    horizontalBox.add(Box.createGlue());
	    horizontalBox.add(xLabel);	    
	    horizontalBox.add(new JLabel(" / "));
	    horizontalBox.add(yLabel);
	    horizontalBox.add( Box.createHorizontalStrut(10) );	    
	    
	    setLayout(new BorderLayout());
	    add(horizontalBox);	    
	}

	private void createLabels() {
		taskLabel = new JLabel("");
		xLabel = new JLabel("x:0   ");
		yLabel = new JLabel("y:0   ");
	}

	public void updatePointInfo(Point point) {
		xLabel.setText("x:" + pad(point.x));
		yLabel.setText("y:" + pad(point.y));
	}

	public void taskName(String name) {
		taskLabel.setText( name );
	}
	
	// converts the integer to a string, padding with space
	private String pad(int v) {
		String s = "" + v;
		int len = s.length();
		for(int i = len + 1; i <= 4; i++)
			s += " ";
		return s;
	}
}
