package taskeditor.changetrace;

public class Change {
	
	protected ChangedObj  objType; 
	protected ChangeType  chType;
	private   int  		  sequenceNumber = 0;		// to keep the order of changes
	private   static int  sequenceCounter = 0; 
	
	protected Change() {
		sequenceNumber = sequenceCounter;
		sequenceCounter++;
	}
	
	public boolean isJobChange() {
		return objType == ChangedObj.Job; 
	}
	
	public boolean isEdgeChange() {
		return objType == ChangedObj.Edge; 
	}
	
	public boolean isTaskChange() {
		return objType == ChangedObj.Task; 
	}
	
	public boolean isGroupChange() {
		return objType == ChangedObj.Group;  // A list of changes		
	}
	
	public boolean isCreate() {
		return chType == ChangeType.Create; 
	}
	
	public boolean isModify() {
		return chType == ChangeType.Modify; 
	}
	
	public boolean isRemove() {
		return chType == ChangeType.Remove; 
	}
	
	public void beCreate() {
		chType = ChangeType.Create;
	}
	
	public void beModify() {
		chType = ChangeType.Modify;		
	}
	
	public void beRemove() {
		chType = ChangeType.Remove;
	}

	public int seqNo() {
		return sequenceNumber;
	}
	
	public String toString() {
		String s = "Change type = " + chType;
		s += "\r\nObject type = " + objType;
		s += "\r\nSequence Number = " + sequenceNumber;
		return s;
	}
}

enum ChangedObj {
	Edge, Job, Task ,Group
}

enum ChangeType {
	Create, Remove, Modify
}