package taskeditor.changetrace;

import main.JobType;
import main.Task;

/* 
 * This is used for tracking only those changes
 *   made in primitive variables. 
 *   The changes related to jobs and edges, 
 *   even their creation/removal are tracked 
 *   by themselves. 
 * 
 */
public class TaskChange extends Change {
	
	Task reference; // the actual object
	Task orig;		// the copy (cloned) version
	JobType	startJob;
	
	
	public TaskChange() {
		super();		
		objType = ChangedObj.Task;
	}
	
	public void setRef(Task ref) {
		reference = ref;
	}
	
	public void setOrig(Task orig) {
		this.orig = orig;
	}
	
	public void setStartJob(JobType j) {
		this.startJob = j;
	}

	public void undoModify() {
		if(!isModify())
			System.out.println("Warning: this is not a modify change!");
		
		reference.loadData(orig);
		reference.setStartJob(startJob);		
	}

	public void undoRemove() {
				
	}
	
	public Task getReference() {
		return reference;
	}
}
