package taskeditor.listeners;

import java.awt.event.MouseEvent;

import main.Edge;

import taskeditor.DrawingPane;
import taskeditor.changetrace.Change;

public class EdgeLabelListener extends MovableListener {
    private Edge edge;   // the related edge 
    
    public EdgeLabelListener(DrawingPane pane, Edge edge) {
    	super(pane);
    	this.edge = edge;
	}

    public void selected(MouseEvent e) {
    	drawPane.edgeSelected(edge);
    	edge.selected();
    }
    
	protected void dragged(int dx, int dy) {	}
    
    public void mouseClicked(MouseEvent e) {
    	if (e.getClickCount() == 2) {
    		trackModifChange();
    		edge.editRequest();            	
    		drawPane.updateTaskInfo();
        }
    }

	protected void trackModifChange() {
		Change ch = edge.getModifyChange();
		drawPane.trackChange(ch);
	}	
}
