package taskeditor.listeners;

import java.awt.Dialog;
import java.awt.GridLayout;
import java.awt.event.MouseEvent;

import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import main.JobType;
import main.Util;

import taskeditor.DrawingPane;
import taskeditor.changetrace.Change;
import util.Dialogs;
import util.GUIUtil;

// The listener class is for the text label of a jobtype (which represents its WCET and DL)
public class JobLabelListener extends MovableListener {
    private JobType		job;

    public JobLabelListener(DrawingPane pane, JobType owner) {
    	super(pane);
    	job = owner;
	}
    
    // When mouse pressed
    public void selected(MouseEvent e) {
    	drawPane.jobSelected(job);        
    }

    public void dragged(int dx, int dy) {   
    	// job.moveLabelXY(dx, dy);
    }
    
    public void mouseClicked(MouseEvent e) {
        if (e.getClickCount() == 2) {
        	JTextField tf1 = GUIUtil.formattedField(job.WCET + ""); 
        	JTextField tf2 = GUIUtil.formattedField(job.deadline + "");        	
        	JPanel p = Two_Texts_Panel(tf1, tf2, "WCET:", "Deadline:  ");
            int result = Dialogs.showOkCancelPanel(p, "Job Parameters"); 
            if (result == JOptionPane.OK_OPTION) {
            	boolean valid = check(tf1, tf2);
            	if (valid == false) {
            		mouseClicked(e);
            		return;      			
            	}
            	int WCET     = Integer.parseInt(tf1.getText());
                int deadline = Integer.parseInt(tf2.getText());
                
                drawPane.trackChange(job.getModifyChange());
                job.updateWCET_DL(WCET, deadline);                
                drawPane.updateTaskInfo();
            }
        }
    }

	private boolean check(JTextField tf1, JTextField tf2) {
		boolean b1 = Util.checkIntVal(tf1.getText(), "WCET");
		boolean b2 = Util.checkIntVal(tf2.getText(), "Deadline");
		return b1 && b2;
	}

	private JPanel Two_Texts_Panel(JTextField tf1, JTextField tf2, String s1, String s2) {
    	
        JLabel l1 = new JLabel(s1);
        JLabel l2 = new JLabel(s2);
        
        JPanel p = new JPanel(new GridLayout(2, 2));
        p.add(l1);
        p.add(tf1);
        p.add(l2);
        p.add(tf2);
		return p;
	}

	protected void trackModifChange() {
		Change ch = job.getModifyChange();
		drawPane.trackChange(ch);
	}
}