package taskeditor.movables;

import java.awt.Point;
import java.awt.Rectangle;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;

import taskeditor.DrawingPane;
import taskeditor.listeners.JobIconListener;

import main.JobType;
import main.Util;

public class JobIcon extends Movable {
	
	public JobIcon(DrawingPane drawPane, JobType j, boolean startJob, int x, int y) {
		super();
		ImageIcon img;
		if (startJob)
			img = Util.getIcon("/start_node.png");
		else
			img = Util.getIcon("/circle.png");
		setIcon(img);		
		
		JobIconListener lsnr = new JobIconListener(drawPane, j);
		setListener(lsnr);
		
		setHorizontalAlignment(JLabel.CENTER);
		Rectangle bnd = new Rectangle(new Point(100, 100), getPreferredSize());
		setBounds(bnd);		

		setText(j.getName());
		setLocation(x, y);		
		Icon icon = getIcon();
		if (icon != null) {		
			int lx = (int)(x - icon.getIconWidth() / 2.0);
			int ly = (int)(y - icon.getIconHeight() / 2.0);        
			setLocation(lx, ly);
		}
	}

}
