package taskeditor.movables;


import java.awt.Point;

import main.JobType;
import taskeditor.DrawingPane;
import taskeditor.listeners.JobLabelListener;

public class JobLabel extends MovableLabel {

	public JobLabel(JobType j, int x, int y) {
		super();
		adjustSizeAndLocation(x, y);
		setText(j.WCET, j.deadline);
	}
	
	public void setListeners(DrawingPane p, JobType j) {
		super.setListener(new JobLabelListener(p, j));
	}
	
	public void adjustSizeAndLocation(Point p) {
		adjustSizeAndLocation(p.x, p.y);
	}
			
	public void setText(int WCET, int deadline) {
		setText("(" + WCET + ", " + deadline + ")");
	}
	
	public JobLabel cloneMe(JobType j) {
		Point p = getXY();
		JobLabel l = new JobLabel(j, p.x, p.y);
		return l;
	}
}
