package taskeditor.movables;

import java.awt.Point;
import java.awt.Rectangle;

import taskeditor.listeners.MovableListener;

public class MovableLabel extends Movable {
	
	private	boolean	listenersSet = false; 	

	protected void setListener(MovableListener listener) {
		super.setListener(listener);
		listenersSet = true;
	}

	// x and y show the location of the "center" of the label
	public void adjustSizeAndLocation(int x, int y) {
		Rectangle rec = getBounds();
        rec.width  = getPreferredSize().width;
        rec.height = getPreferredSize().height;
        setBounds(rec);
        
        int xx = x - rec.width/2;
        int yy = y - rec.height/2;
        setLocation(xx, yy);
	}
	
	public Point getXY() {
		Rectangle rec = getBounds();
        rec.width  = getPreferredSize().width;
        rec.height = getPreferredSize().height;
        
        int x = getX() + rec.width/2;
        int y = getY() + rec.height/2;
        return new Point(x, y);
	}
	
	public void _move(int dx, int dy) {
		setLocation(getX() + dx, getY() + dy);		
	}
	
	public void setText(String s) {
		Point p = getXY();	// current center location
		super.setText(s);
		adjustSizeAndLocation(p.x, p.y);		
	}
	
	public boolean listenersSet() {
		return listenersSet;
	}
}
