package taskeditor.movables;

import java.awt.Point;

import main.Edge;
import main.Util;

public class Nail  {
	
	private Edge	edge;
	private Point 	position;	
	private Point 	lastPos;	// used when moving 
	
	public Nail(int x, int y, Edge e) {
		edge = e;
		position = new Point(x, y);
	}

	public Nail(Point p, Edge e) {
		edge = e;
		position = new Point(p.x, p.y);
	}

	public int x() {
		return position.x;
	}	
	
	public int y() {
		return position.y;
	}

	public Point position() {
		return position;
	}

	public Edge myEdge() {
		return edge;
	}

	public boolean isBetween(Point n1, Point n2) {
		int x1 = Math.min(n1.x, n2.x);
		int y1 = Math.min(n1.y, n2.y);
		int x2 = Math.max(n1.x, n2.x);
		int y2 = Math.max(n1.y, n2.y);
		// Whether this is in the middle of two nails n1 and n2:
		if (x1 <= x() && x() <= x2 && y1 <= y() && y() <= y2) {
			return true;
		}			
		return false;
	}

	// mouse pressed
	public void pressed(Point p) {
		lastPos = new Point(x() - p.x, y() - p.y);		
	}

	public void dragged(Point p, boolean snapped, int gridX, int gridY) {
		int x = p.x + lastPos.x;
		int y = p.y + lastPos.y;
		if (snapped) {
			x = Util.discritize(x, gridX);
			y = Util.discritize(y, gridY);
		}
		position.x = x;
		position.y = y;
	}	
}
